Redmine - Feature #3801

Links to external pages should get a target="_blank" attribute
2009-09-01 09:09 - Roderik van der Veer

Status: Closed Start date: 2009-09-01
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Text formatting Estimated time: 0.00 hour
Target version:

Resolution: Duplicate

Description

When using links in the descriptions of bugs (happens a lot if you use redmine for web projects), the automatic link replacer should
add a target="_blank" to these links. Because while you want to go and view these links, you still need the tickets and redmine
system as well.

Related issues:
Is duplicate of Redmine - Feature #1151: Open Links in New-Window New 2008-05-01

History

#1 - 2009-09-03 11:16 - Ewan Makepeace

| dont get it - surely you just ctrl-click (or whatever your browser needs) to open all the linked pages in new tabs? | think explictly setting the target
could have nasty side effects from time to time, and give me no real convenience?

#2 - 2009-09-03 12:24 - Roderik van der Veer
My problem with external links is that while following the links from a redmine ticket, the context of the ticket is gone unless you press your back
button a few times, or you enter the redmine url again and look for the ticket again.

While you might be correct to assume there might be some other consequences a lot of intermediate solutions are available, see this acticle:
http://www.sitepoint.com/article/beware-opening-links-new-window/

The icons is also the way sites like wikipedia handle external links.

#3 - 2009-09-03 15:51 - Anonymous

+1 on _blank ( or config option )

#4 - 2009-09-03 22:26 - Adam Piotr Zochowski

Ctrl-click doesn't work on all browsers:

e Chrome : ctrl-click

e Firefox : ctrl-click

¢ QOpera : ctrl-shift-click
e |E : shift-click

Alternatively, there is also the middle-click.

No self respecting site, that | know, does this to its users. Please refer to see how wikipedia, google, slashdot and even smaller sites like digg/reddit
work. Neither open new windows.

#5 - 2009-11-20 14:32 - Henrik Ammer
Roderik van der Veer wrote:

My problem with external links is that while following the links from a redmine ticket, the context of the ticket is gone unless you press your back
button a few times, or you enter the redmine url again and look for the ticket again.

While you might be correct to assume there might be some other consequences a lot of intermediate solutions are available, see this acticle:
http://www_sitepoint.com/article/beware-opening-links-new-window/

The icons is also the way sites like wikipedia handle external links.

| agree that PDFs etc that should be downloaded should open in a new window but with obfuscated URLs, how do we tell them apart? For instance, a
bit.ly link can link to a PDF or a webpage and there is no way of knowing.

2025-05-17 1/3



http://www.sitepoint.com/article/beware-opening-links-new-window/
http://www.sitepoint.com/article/beware-opening-links-new-window/

Anything else is up to the user to choose. If | want a new window (or rather tab for that matter) | middleclick in Firefox and | have it, if | wish to leave
the site and read on | just click the link. Don't force me to see new windows/tabs when I click external links if | don't want to, it's just bad practice and
will get the users blood boiling.

My $.02

#6 - 2010-07-22 16:56 - Olivier Farlotti

While i understand you, the fact is that is damageable for users that don't want _blank link since they can't get the original behavior of the link back.
More over it's not considered as a good practice by W3C for accessibility et usability purpose

#7 - 2011-10-05 12:06 - Matt N

+1 for allowing a config. While users can do extra clicks, it's not necessarily convenient. Besides, Redmine makes uses of this in things like help.
Under Chrome:

Help->Text Formatting : brings up a popup
Help->Text Formatting->More Information : brings up a new tab from the popup

#8 - 2011-10-05 18:34 - Mischa The Evil
Matt N wrote:
[...] Besides, Redmine makes uses of this in things like help.
Under Chrome:
e Help->Text Formatting : brings up a popup

¢ Help->Text Formatting->More Information : brings up a new tab from the popup

True, but the textformatting "help" link is different since there is a specific need to open these links in other popups/tabs. You can't compare these two
things IMHO.

#9 - 2011-10-07 13:16 - Matt N

Agreed, but we're also making (incorrect) presumptions, by not allowing these action, that folks won't have specific needs themselves to open their
links in other tabs.

#10 - 2012-05-03 08:10 - Rob C

| would really like this feature. External links should open in a new window (or best case it would be a setting | could enable).

#11 - 2013-02-07 13:48 - Filou Centrinov

+1

#12 - 2013-02-07 16:52 - Daniel Felix
- Status changed from New to Closed

- Resolution set to Duplicate

Closing this as duplicate of #1151.

#13 - 2013-02-09 02:33 - Filou Centrinov

Fix:

/lib/redcloth3.rb

- external = (url =~ /“https?:\/\//) ? ' class="external"' : "'

+ external = (url =~ /~https?:\/\//) ? ' class="external" target="_blank"' : ''

/lib/redmine/wiki_formatatting.rb

- % (#{leading}<a class="external" href="#{ERB::Util.html_escape href}">#{ERB::Util.html_escape content}</a>#{p
ost}) .html_safe

+ % (#{leading}<a class="external" target="_blank" href="#{ERB::Util.html_escape href}">#{ERB::Util.html_escape

content}</a>#{post}) .html_safe

Add this to your Stylesheets:
/public/stylesheets/application.css

a.external {
background-position: 0% 60%;
background-repeat: no-repeat;
padding-left: 12px;
background-image: url(../images/external.png);

#14 - 2013-02-22 17:58 - Filou Centrinov

Alternative without changing system:
Add the following code at the end of /public/javascripts/application.js

function addTargetExternalLinks () {
$('a.external') .each(function () {
$(this) .attr('target', '_blank');
b
}

$ (document) .ready (addTargetExternallLinks) ;

#15 - 2014-08-19 09:37 - Samuel Suther

This is still not implemented in the Core till now.
Would be gread if Redmine had this feature out of the Box!!!

#16 - 2015-05-03 13:04 - Miroslav Zatko

+1
Would be great if Redmine had this feature!

#17 - 2015-08-13 12:35 - Viktor Neufeld
For other people who find this.
Debian 7, Redmine 1.4.4
Similar as Filou Centrinov mentioned above, add this at the end of your /public/javascripts/application.js
function addTargetExternallLinks () {
$$('.external') .each (function (link) {
link.setAttribute ('target','_blank');
b i
}

Event .observe (window, 'load', addTargetExternallinks);
#18 - 2016-02-16 16:08 - Anthony Cartmell
For Redmine 3.1.3, add this to the bottom of /public/javascripts/application.js:
function addTargetExternallLinks () {

$('.external') .attr("target", "_blank");
}

$ (document) .ready (addTargetExternallinks) ;

Update 5 July 2019: This still works nicely, with Redmine 4 too. Following adding this code, you might need to get your browser to re-load the
application.js file instead of using the old one in the browser's cache.

See also #1151
